"service nginx start"를 사용하여 Nginx가 정지됨


12

프로덕션 서버의 사용자 정의 경로로 nginx를 컴파일했으며 다음을 사용하여 서비스를 시작 / 다시 시작하려고합니다.

service nginx start

또는

service nginx restart

쉘을 반환하지 않고 새 줄에 들어갑니다. 명령을 실행할 때의 터미널 그림

따라서 문제는 service명령을 사용하여 nginx를 제어 할 수 없다는 것 입니다. 서비스는 실제로 실행되지만 쉘을 반환하지 않으므로 항상 ctrl+ c를 눌러 다시 가져와야합니다.

또한 nginx는 자체 nginx명령으로 호출 할 때 제대로 실행되고을 사용하여 쉽게 중지하거나 다시로드 한다고 언급해야 nginx -s stop/reload합니다.

이 문제는 계속 사용 systemctl start nginx되지만 잘 systemctl stop nginx작동합니다.

정보 :

$ lsb_release -a
    Distributor ID: Ubuntu
    Description:    Ubuntu 15.10
    Release:    15.10
    Codename:   wily

$ uname -r
    4.2.0-27-generic

$ nginx -V
    nginx version: nginx/1.9.11
    built by gcc 5.2.1 20151010 (Ubuntu 5.2.1-22ubuntu2) 
    built with OpenSSL 1.0.2d 9 Jul 2015
    TLS SNI support enabled
    configure arguments: --sbin-path=/usr/bin/nginx --conf-path=/etc/nginx/nginx.conf --error-log-path=/var/log/nginx/error.log --http-log-path=/var/log/nginx/access.log --with-debug --with-pcre --with-http_ssl_module

$ cat /etc/default/nginx
    NGINX_CONF_FILE=/etc/nginx/nginx.conf
    DAEMON=/usr/bin/nginx

$ cat /etc/init.d/nginx
    NGINX_BIN=/usr/bin/nginx
    test -x $NGINX_BIN || { echo "$NGINX_BIN not installed"; 
        if [ "$1" = "stop" ]; then exit 0;
        else exit 5; fi; }
    NGINX_PID=/var/run/nginx.pid

    # Check for existence of needed config file and read it
    #NGINX_CONFIG=/etc/sysconfig/nginx
    #test -r $NGINX_CONFIG || { echo "$NGINX_CONFIG not existing";
    #   if [ "$1" = "stop" ]; then exit 0;
    #   else exit 6; fi; }
    #
    # Read config   
    #. $NGINX_CONFIG

    # Source LSB init functions
    # providing start_daemon, killproc, pidofproc, 
    # log_success_msg, log_failure_msg and log_warning_msg.
    # This is currently not used by UnitedLinux based distributions and
    # not needed for init scripts for UnitedLinux only. If it is used,
    # the functions from rc.status should not be sourced or used.
    #. /lib/lsb/init-functions

    # Shell functions sourced from /etc/rc.status:
    #      rc_check         check and set local and overall rc status
    #      rc_status        check and set local and overall rc status
    #      rc_status -v     be verbose in local rc status and clear it afterwards
    #      rc_status -v -r  ditto and clear both the local and overall rc status
    #      rc_status -s     display "skipped" and exit with status 3
    #      rc_status -u     display "unused" and exit with status 3
    #      rc_failed        set local and overall rc status to failed
    #      rc_failed <num>  set local and overall rc status to <num>
    #      rc_reset         clear both the local and overall rc status
    #      rc_exit          exit appropriate to overall rc status
    #      rc_active        checks whether a service is activated by symlinks
    . /etc/rc.status

    # Reset status of this service
    rc_reset

    # Return values acc. to LSB for all commands but status:
    # 0   - success
    # 1       - generic or unspecified error
    # 2       - invalid or excess argument(s)
    # 3       - unimplemented feature (e.g. "reload")
    # 4       - user had insufficient privileges
    # 5       - program is not installed
    # 6       - program is not configured
    # 7       - program is not running
    # 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
    # 
    # Note that starting an already running service, stopping
    # or restarting a not-running service as well as the restart
    # with force-reload (in case signaling is not supported) are
    # considered a success.

    case "$1" in
        start)
        echo -n "Starting nginx "
        ## Start daemon with startproc(8). If this fails
        ## the return value is set appropriately by startproc.
        /sbin/startproc -p $NGINX_PID $NGINX_BIN

        # Remember status and be verbose
        rc_status -v
        ;;
        stop)
        echo -n "Shutting down nginx "
        ## Stop daemon with killproc(8) and if this fails
        ## killproc sets the return value according to LSB.

        /sbin/killproc -p $NGINX_PID -TERM $NGINX_BIN

        # Remember status and be verbose
        rc_status -v
        ;;
        try-restart|condrestart)
        ## Do a restart only if the service was active before.
        ## Note: try-restart is now part of LSB (as of 1.9).
        ## RH has a similar command named condrestart.
        if test "$1" = "condrestart"; then
            echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
        fi
        $0 status
        if test $? = 0; then
            $0 restart
        else
            rc_reset    # Not running is not a failure.
        fi
        # Remember status and be quiet
        rc_status
        ;;
        restart)
        ## Stop the service and regardless of whether it was
        ## running or not, start it again.
        $0 stop
        $0 start

        # Remember status and be quiet
        rc_status
        ;;
        force-reload)
        ## Signal the daemon to reload its config. Most daemons
        ## do this on signal 1 (SIGHUP).
        ## If it does not support it, restart the service if it
        ## is running.

        echo -n "Reload service nginx "
        ## if it supports it:
        /sbin/killproc -p $NGINX_PID -HUP $NGINX_BIN
        #touch /run/nginx.pid
        rc_status -v

        ## Otherwise:
        #$0 try-restart
        #rc_status
        ;;
        reload)
        ## Like force-reload, but if daemon does not support
        ## signaling, do nothing (!)

        # If it supports signaling:
        echo -n "Reload service nginx "
        /sbin/killproc -p $NGINX_PID -HUP $NGINX_BIN
        #touch /run/nginx.pid
        rc_status -v

        ## Otherwise if it does not support reload:
        #rc_failed 3
        #rc_status -v
        ;;
        reopen)
            echo -n "Reopen the logfiles "
            /sbin/killproc -p $NGINX_PID -USR1 $NGINX_BIN
            rc_status -v
            ;;

        status)
        echo -n "Checking for service nginx "
        ## Check status with checkproc(8), if process is running
        ## checkproc will return with exit status 0.

        # Return value is slightly different for the status command:
        # 0 - service up and running
        # 1 - service dead, but /run/  pid  file exists
        # 2 - service dead, but /var/lock/ lock file exists
        # 3 - service not running (unused)
        # 4 - service status unknown :-(
        # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)

        # NOTE: checkproc returns LSB compliant status values.
        /sbin/checkproc -p $NGINX_PID $NGINX_BIN
        # NOTE: rc_status knows that we called this init script with
        # "status" option and adapts its messages accordingly.
        rc_status -v
        ;;
        probe)
        ## Optional: Probe for the necessity of a reload, print out the
        ## argument to this init script which is required for a reload.
        ## Note: probe is not (yet) part of LSB (as of 1.9)

        test /etc/nginx/nginx.conf -nt /run/nginx.pid && echo reload
        ;;
        *)
        echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
        exit 1
        ;;
    esac
    rc_exit

업데이트 : CoreOS alpha에서 Docker 컨테이너를 사용하는 동안 문제가 지속됩니다.

업데이트 2 : strace -o log -f service nginx start및에 대한 출력은 다음 과 journalctl -xe같습니다.

strace -o log -f service nginx start 로그 출력 [너무 오래 게시 할 수 없습니다]


    journalctl -xe
    Feb 26 07:25:38 lucifer polkitd(authority=local)[870]: Registered Authentication Agent for unix-process:8181:8813595 (system bus name :1.77 [/usr/bin/pkttyagent --notify-fd 5 --fallback], o
Feb 26 07:25:38 lucifer systemd[1]: Starting The NGINX HTTP and reverse proxy server...
-- Subject: Unit nginx.service has begun start-up
-- Defined-By: systemd
-- Support: http://lists.freedesktop.org/mailman/listinfo/systemd-devel
-- 
-- Unit nginx.service has begun starting up.
Feb 26 07:25:38 lucifer nginx[8211]: nginx: the configuration file /etc/nginx/nginx.conf syntax is ok
Feb 26 07:25:38 lucifer nginx[8211]: nginx: configuration file /etc/nginx/nginx.conf test is successful
Feb 26 07:25:38 lucifer systemd[1]: nginx.service: PID file /var/run/nginx.pid not readable (yet?) after start: No such file or directory
Feb 26 07:25:43 lucifer polkitd(authority=local)[870]: Unregistered Authentication Agent for unix-process:8181:8813595 (system bus name :1.77, object path /org/freedesktop/PolicyKit1/Authen

1
nginx자체적으로 cli에서 시작할 때 제대로 작동 하므로 서비스 스크립트 를 디버그해야합니다 .
drookie

문제를 해결하십시오. 완료 할 수없는 시스템 호출을 보여줍니다. strace를 설치 한 다음 strace -ff service nginx start를 실행하십시오.
anx

@drookie 내가 결과를 게시 한 @anx journalctl하고 strace여기하지만 솔직히 내가 어떻게 strace를의 출력에서 문제를 이해하는 단서가 없다. 가능하다면 약간의 도움을 부탁드립니다.
T0M XeOn LuCiFeR

@ T0M XeOn LuCiFeR이 문제를 해결 했습니까?
Bhargav Patel

이 버그와 관련이있을 수 있습니다. bugs.launchpad.net/ubuntu/+source/nginx/+bug/1581864
Elliott B

답변:


9

소스의 Ubuntu 16.04, systemd 및 NginX 1.10.1과 동일한 문제가 있습니다.

기본 nginx.service 파일을 사용하고 있습니다 : https://www.nginx.com/resources/wiki/start/topics/examples/systemd/

문제는 그것을 해결하기 위해 nginx.pid lcoation이었습니다.

서비스없이 Nginx를 시작

sudo nginx start

locate db를 업데이트했습니다 :

sudo updatedb

pid 파일의 위치를 ​​찾았습니다

locate "nginx.pid"

그리고 nginx.service 파일을 찾은 위치로 업데이트했습니다.

PIDFile=/usr/local/nginx/logs/nginx.pid

(왜 내 로그 디렉토리에 저장되는지 모르겠습니다 ...)

그런 다음 daemon-reload를 실행하여 nginx.service 파일을 다시로드하십시오.

systemctl daemon-reload

그 후 "systemctl start nginx"는 매력처럼 작동합니다. 도움이 되었기를 바랍니다.


주어 /usr/local/nginx/logs/nginx.pid에 대한 경로로 PIDFile(우분투 서버 16.04.2와의 nginx 1.12.1을 사용하여) 날 위해 일했습니다. Thx
youssman

그것은 나를 위해 일했다. 소스에서 nginx를 빌드 할 때 "--pid-path = / usr / local / nginx / nginx.pid"로 구성했습니다. nginx.service를 설정할 때 잘못된 경로를 사용하여 동일한 문제가 발생했습니다. 수정해도 중단 및 후속 종료가 발생하지 않았습니다. 감사!
geeth

3

이 오류로 인해 정지됩니다.

PID file /var/run/nginx.pid not readable (yet?) after start

최신 Linux 배포판은 systemd 와 함께 제공됩니다 . 배포판과 함께 번들로 제공되는 서비스를 사용하는 경우 이미 systemd에 맞게 구성되어 있습니다.

소스에서 nginx를 컴파일하고 SysV init 파일 ( /etc/init.d/nginx )을 사용하고 있으므로 systemd는 생성기를 사용하여 파일 을 구문 분석합니다 ( systemd-sysv-generator ).

SysV 스크립트에서 pid 파일을 정의하고 다음을 사용하여 프로세스를 시작하십시오.

NGINX_PID=/var/run/nginx.pid
...
/sbin/startproc -p $NGINX_PID $NGINX_BIN

내가 틀리지 않으면 우분투에서 SUSE Linux init 스크립트를 사용하고 있습니다 ( startproc 명령으로 인해 ) startproc 명령은 pid 파일 ( -p 매개 변수로 지정) 만 읽습니다. pid 파일을 찾을 수 없어서 정지합니다.

귀하의 경우 해결책은 SysV init 스크립트 ( /var/run/nginx.pid 위치) 에 pid 파일을 생성 하거나 Ubuntu SysV init 스크립트 또는 시스템 스크립트를 사용하는 것입니다.

pid 파일을 생성하는 올바른 SysV init 스크립트를 가지고있을 때도 이런 일이 발생할 수 있습니다 (하지만 발생하지는 않음). 파일 상단에 주석이 달린 것과 다릅니다. 시스템 생성기는 다음과 같은 주석을 읽습니다.

# pidfile: /var/run/nginxd.pid

그리고 거기에 정의 된 pidfile을 사용합니다.

추가 정보:


2

/usr/lib/systemd/system/nginx.service잘못된 것 같습니다 . 이 줄이 설정되어 있는지 확인하십시오.

PIDFile=/var/run/nginx.pid

또는 [Service]섹션을이라는 새 파일로 복사 할 수 있습니다 /etc/systemd/system/nginx.service. 배치 된 장치 파일을 /etc/systemd/system사용하면 패키지 관리자가 설치 한 전체 파일을 복제하지 않고도 섹션을 무시할 수 있습니다.

당사 사이트를 사용함과 동시에 당사의 쿠키 정책개인정보 보호정책을 읽고 이해하였음을 인정하는 것으로 간주합니다.
Licensed under cc by-sa 3.0 with attribution required.